-- ZB_DM_FCXWJDD ZB_DM_非车未决大单
-- bigfclpbdt/日期
-- 估损调整日期在今天，按照估损金额排序，取前20，车险riskcode 05开头，其他为非车，

-- 总公司
insert into ZB_DM.ZB_DM_REDIS.SET_VARCHAR
select 
    CONCAT(
        'bigfclpbdt/'
        ,s1.`setdate`
    )                      as `key` 
    ,CastToJsonArrayUDF(
        listagg(concat(
             'com'      ,':'  ,`com`      ,',' 
            ,'maincom'  ,':'  ,`maincom`  ,',' 
            ,'no'       ,':'  ,`no`       ,',' 
            ,'claimno'  ,':'  ,`claimno`  ,',' 
            ,'cost'     ,':'  ,`cost`     ,',' 
            ,'comname'  ,':'  ,`comname`  ,',' 
            ,'chnl'     ,':'  ,`chnl`     ,',' 
            ,'mainkey'  ,':'  ,`mainkey`  ,',' 
            ,'riskname' ,':'  ,`riskname` ,',' 
            ,'chnlname' ,':'  ,`chnlname` ,',' 
            ,'risk'     ,':'  ,`risk`
        ),';')
    )                      as `val` 
from (
    select
        *
    from(
        select
            d1.`setdate`                                        as `setdate`
            ,d1.`LEVEL1COMCODE`                                 as `com`  
            ,d1.`LEVEL1COMDESC`                                 as `comname`    
            ,d1.`LEVEL1COMCODE`                                 as `maincom` 
            ,d1.`no`                                            as `no`      
            ,d1.`claimno`                                       as `claimno` 
            ,d1.`cost`                                          as `cost`                
            ,d1.`chnl`                                          as `chnl` 
            ,d1.`chnlname`                                      as `chnlname`   
            ,CAST(d1.`LEVEL1COMCODE`,d1.`claimno`,d1.`no`)      as `mainkey`               
            ,d1.`risk`                                          as `risk`  
            ,d1.`riskname`                                      as `riskname`   
            ,ROW_NUMBER() OVER(PARTITION BY d1.`setdate` ORDER BY d1.`lossamout` DESC) as rownum 
        from ZB_ODS.ZB_ODS_KAFKA.LPDATA d1
        where 
            d1.`COMNAME` is not null
            and d1.`flag` = 'wj'
            and LEFT(s1.`setdate`,8) = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd') 
            and LEFT(d1.`risk`,2) <> '05'
    ) c1
    where c1.rownum <= 20 
    ORDER by 
        c1.`cost`
        asc
) s1
group by 
    s1.`setdate`
;



-- 分公司
insert into ZB_DM.ZB_DM_REDIS.SET_VARCHAR
select 
    CONCAT(
        'bigcitylpbdt/' 
        ,s1.`setdate`
        ,'/',s1.`group_com`
    )                      as `key` 
    ,CastToJsonArrayUDF(
        listagg(concat(
            'com'      ,':'  ,`com`      ,','
           ,'maincom'  ,':'  ,`maincom`  ,','
           ,'city'     ,':'  ,`city`     ,','
           ,'cityname' ,':'  ,`cityname` ,','
           ,'no'       ,':'  ,`no`       ,','
           ,'claimno'  ,':'  ,`claimno`  ,','
           ,'cost'     ,':'  ,`cost`     ,','
           ,'comname'  ,':'  ,`comname`  ,','
           ,'chnl'     ,':'  ,`chnl`     ,','
           ,'mainkey'  ,':'  ,`mainkey`  ,','
           ,'riskname' ,':'  ,`riskname` ,','
           ,'chnlname' ,':'  ,`chnlname` ,','
           ,'risk'     ,':'  ,`risk`
        ),';')
    )                      as `val` 
from (
    select
        *
    from (
        select
             d1.`setdate`                                       as `setdate`
            ,d1.`LEVEL1COMCODE`                                 as `group_com`
            ,d1.`LEVEL1COMCODE`                                 as `com`
            ,d1.`LEVEL1COMDESC`                                 as `comname`    
            ,d1.`LEVEL1COMCODE`                                 as `maincom`
            ,d1.`LEVEL2COMDESC`                                 as `city`    
            ,d1.`LEVEL2COMCODE`                                 as `cityname` 
            ,d1.`no`                                            as `no`      
            ,d1.`claimno`                                       as `claimno` 
            ,d1.`cost`                                          as `cost`                
            ,d1.`chnl`                                          as `chnl` 
            ,d1.`chnlname`                                      as `chnlname`   
            ,CAST(d1.`LEVEL1COMCODE`,d1.`claimno`,d1.`no`)      as `mainkey`               
            ,d1.`risk`                                          as `risk`  
            ,d1.`riskname`                                      as `riskname`   
            ,ROW_NUMBER() OVER(PARTITION BY d1.`LEVEL1COMCODE`,d1.`setdate` ORDER BY d1.`lossamout` DESC) as rownum
        from ZB_ODS.ZB_ODS_KAFKA.LPDATA d1
        where 
            d1.`COMNAME` is not null
            and d1.`flag` = 'wj'
            and LEFT(s1.`setdate`,8) = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd') 
            and LEFT(d1.`risk`,2) <> '05'
    ) c1
    where c1.rownum <= 20 
    ORDER by 
        c1.`cost`
        asc
) s1
group by 
    s1.`setdate`
    ,s1.`group_com`
;


-- 中支
insert into ZB_DM.ZB_DM_REDIS.SET_VARCHAR
select
    CONCAT(
            'bigcountrylpbdt/'
        ,s1.`setdate`
        ,'/',s1.`group_com`
        )                      as `key`
     ,CastToJsonArrayUDF(
        listagg(concat(
             'com'         ,':'  ,`com`         ,','
            ,'maincom'     ,':'  ,`maincom`     ,','
            ,'city'        ,':'  ,`city`        ,','
            ,'cityname'    ,':'  ,`cityname`    ,','
            ,'country'     ,':'  ,`country`     ,','
            ,'countryname' ,':'  ,`countryname` ,','
            ,'no'          ,':'  ,`no`          ,','
            ,'claimno'     ,':'  ,`claimno`     ,','
            ,'cost'        ,':'  ,`cost`        ,','
            ,'comname'     ,':'  ,`comname`     ,','
            ,'chnl'        ,':'  ,`chnl`        ,','
            ,'mainkey'     ,':'  ,`mainkey`     ,','
            ,'riskname'    ,':'  ,`riskname`    ,','
            ,'chnlname'    ,':'  ,`chnlname`    ,','
            ,'risk'        ,':'  ,`risk`
            ),';')
        )                      as `val`
from (
     select
         *
     from (
        select
             d1.`setdate`                                       as `setdate`
            ,d1.`LEVEL2COMCODE`                                 as `group_com`
            ,d1.`LEVEL1COMCODE`                                 as `com`  
            ,d1.`LEVEL1COMDESC`                                 as `comname`    
            ,d1.`LEVEL1COMCODE`                                 as `maincom`
            ,d1.`LEVEL2COMDESC`                                 as `city`    
            ,d1.`LEVEL2COMCODE`                                 as `cityname` 
            ,d1.`LEVEL3COMCODE`                                 as `country`
            ,d1.`LEVEL3COMDESC`                                 as `countryname`
            ,d1.`no`                                            as `no`      
            ,d1.`claimno`                                       as `claimno` 
            ,d1.`cost`                                          as `cost`                
            ,d1.`chnl`                                          as `chnl` 
            ,d1.`chnlname`                                      as `chnlname`   
            ,CAST(d1.`LEVEL1COMCODE`,d1.`claimno`,d1.`no`)      as `mainkey`               
            ,d1.`risk`                                          as `risk`  
            ,d1.`riskname`                                      as `riskname`   
            ,ROW_NUMBER() OVER(PARTITION BY d1.`LEVEL2COMCODE`,d1.`setdate` ORDER BY d1.`lossamout` DESC) as rownum
         from ZB_ODS.ZB_ODS_KAFKA.LPDATA d1
         where
            d1.`COMNAME` is not null
            and d1.`flag` = 'wj'
            and LEFT(s1.`setdate`,8) = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd') 
            and LEFT(d1.`risk`,2) <> '05'
          ) c1
     where c1.rownum <= 20
     ORDER by
         c1.`cost`
             asc
     ) s1
group by
    s1.`setdate`
   ,s1.`group_com`
;

